## cryfs 0.11.3

=== blobstore/CMakeLists.txt ===
project (blobstore)

set(SOURCES
    implementations/onblocks/parallelaccessdatatreestore/ParallelAccessDataTreeStoreAdapter.cpp
    implementations/onblocks/parallelaccessdatatreestore/DataTreeRef.cpp
    implementations/onblocks/parallelaccessdatatreestore/ParallelAccessDataTreeStore.cpp
    implementations/onblocks/utils/Math.cpp
    implementations/onblocks/BlobStoreOnBlocks.cpp
    implementations/onblocks/datanodestore/DataNode.cpp
    implementations/onblocks/datanodestore/DataLeafNode.cpp
    implementations/onblocks/datanodestore/DataInnerNode.cpp
    implementations/onblocks/datanodestore/DataNodeStore.cpp
    implementations/onblocks/datatreestore/impl/algorithms.cpp
    implementations/onblocks/datatreestore/impl/CachedValue.cpp
    implementations/onblocks/datatreestore/impl/LeafTraverser.cpp
    implementations/onblocks/datatreestore/LeafHandle.cpp
    implementations/onblocks/datatreestore/DataTree.cpp
    implementations/onblocks/datatreestore/DataTreeStore.cpp
    implementations/onblocks/BlobOnBlocks.cpp
)

add_library(${PROJECT_NAME} STATIC ${SOURCES})

target_link_libraries(${PROJECT_NAME} PUBLIC cpp-utils blockstore)

target_add_boost(${PROJECT_NAME})
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== blockstore/CMakeLists.txt ===
project (blockstore)

set(SOURCES
  utils/BlockId.cpp
  utils/IdWrapper.cpp
  utils/BlockStoreUtils.cpp
  utils/FileDoesntExistException.cpp
  implementations/testfake/FakeBlockStore.cpp
  implementations/testfake/FakeBlock.cpp
  implementations/inmemory/InMemoryBlockStore2.cpp
  implementations/parallelaccess/ParallelAccessBlockStore.cpp
  implementations/parallelaccess/BlockRef.cpp
  implementations/parallelaccess/ParallelAccessBlockStoreAdapter.cpp
  implementations/readonly/ReadOnlyBlockStore2.cpp
  implementations/compressing/CompressingBlockStore.cpp
  implementations/compressing/CompressedBlock.cpp
  implementations/compressing/compressors/RunLengthEncoding.cpp
  implementations/compressing/compressors/Gzip.cpp
  implementations/encrypted/EncryptedBlockStore2.cpp
  implementations/ondisk/OnDiskBlockStore2.cpp
  implementations/caching/CachingBlockStore2.cpp
  implementations/caching/cache/PeriodicTask.cpp
  implementations/caching/cache/CacheEntry.cpp
  implementations/caching/cache/Cache.cpp
  implementations/caching/cache/QueueMap.cpp
  implementations/low2highlevel/LowToHighLevelBlock.cpp
  implementations/low2highlevel/LowToHighLevelBlockStore.cpp
  implementations/integrity/IntegrityBlockStore2.cpp
  implementations/integrity/KnownBlockVersions.cpp
  implementations/integrity/ClientIdAndBlockId.cpp
  implementations/mock/MockBlockStore.cpp
  implementations/mock/MockBlock.cpp
)

add_library(${PROJECT_NAME} STATIC ${SOURCES})

target_link_libraries(${PROJECT_NAME} PUBLIC cpp-utils)

target_add_boost(${PROJECT_NAME})
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== cryfs/CMakeLists.txt ===
project (cryfs)

set(LIB_SOURCES
#    cryfs.cpp
        impl/CryfsException.cpp
        impl/config/crypto/outer/OuterConfig.cpp
        impl/config/crypto/outer/OuterEncryptor.cpp
        impl/config/crypto/CryConfigEncryptorFactory.cpp
        impl/config/crypto/inner/ConcreteInnerEncryptor.cpp
        impl/config/crypto/inner/InnerConfig.cpp
        impl/config/crypto/inner/InnerEncryptor.cpp
        impl/config/crypto/CryConfigEncryptor.cpp
        impl/config/CryConfigConsole.cpp
        impl/config/CryConfigLoader.cpp
        impl/config/CryConfig.cpp
        impl/config/CryConfigFile.cpp
        impl/config/CryCipher.cpp
        impl/config/CryConfigCreator.cpp
        impl/config/CryKeyProvider.cpp
        impl/config/CryPasswordBasedKeyProvider.cpp
        impl/config/CryPresetPasswordBasedKeyProvider.cpp
        impl/filesystem/CryOpenFile.cpp
        impl/filesystem/fsblobstore/utils/DirEntry.cpp
        impl/filesystem/fsblobstore/utils/DirEntryList.cpp
        impl/filesystem/fsblobstore/FsBlobStore.cpp
        impl/filesystem/fsblobstore/FsBlobView.cpp
        impl/filesystem/fsblobstore/FileBlob.cpp
        impl/filesystem/fsblobstore/FsBlob.cpp
        impl/filesystem/fsblobstore/SymlinkBlob.cpp
        impl/filesystem/fsblobstore/DirBlob.cpp
        impl/filesystem/CryNode.cpp
        impl/filesystem/parallelaccessfsblobstore/DirBlobRef.cpp
        impl/filesystem/parallelaccessfsblobstore/ParallelAccessFsBlobStore.cpp
        impl/filesystem/parallelaccessfsblobstore/ParallelAccessFsBlobStoreAdapter.cpp
        impl/filesystem/parallelaccessfsblobstore/FsBlobRef.cpp
        impl/filesystem/parallelaccessfsblobstore/FileBlobRef.cpp
        impl/filesystem/parallelaccessfsblobstore/SymlinkBlobRef.cpp
        impl/filesystem/CrySymlink.cpp
        impl/filesystem/CryDir.cpp
        impl/filesystem/cachingfsblobstore/DirBlobRef.cpp
        impl/filesystem/cachingfsblobstore/CachingFsBlobStore.cpp
        impl/filesystem/cachingfsblobstore/FsBlobRef.cpp
        impl/filesystem/cachingfsblobstore/FileBlobRef.cpp
        impl/filesystem/cachingfsblobstore/SymlinkBlobRef.cpp
        impl/filesystem/CryFile.cpp
        impl/filesystem/CryDevice.cpp
        impl/localstate/LocalStateDir.cpp
        impl/localstate/LocalStateMetadata.cpp
        impl/localstate/BasedirMetadata.cpp
)

add_library(${PROJECT_NAME} STATIC ${LIB_SOURCES})
target_link_libraries(${PROJECT_NAME} PUBLIC cpp-utils fspp-interface blockstore blobstore gitversion)
target_add_boost(${PROJECT_NAME}) # TODO Check that dependent projects don't get boost added (use PRIVATE here)
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

#install(TARGETS ${PROJECT_NAME}
#        DESTINATION lib
#        CONFIGURATIONS Release
#)

=== fspp/CMakeLists.txt ===
project (fspp-test)

set(SOURCES
    testutils/FuseTest.cpp
    testutils/FuseThread.cpp
    testutils/InMemoryFile.cpp
    impl/FuseOpenFileListTest.cpp
    impl/IdListTest.cpp
    fuse/lstat/FuseLstatReturnUidTest.cpp
    fuse/lstat/testutils/FuseLstatTest.cpp
    fuse/lstat/FuseLstatReturnCtimeTest.cpp
    fuse/lstat/FuseLstatReturnGidTest.cpp
    fuse/lstat/FuseLstatPathParameterTest.cpp
    fuse/lstat/FuseLstatReturnNlinkTest.cpp
    fuse/lstat/FuseLstatReturnModeTest.cpp
    fuse/lstat/FuseLstatReturnAtimeTest.cpp
    fuse/lstat/FuseLstatErrorTest.cpp
    fuse/lstat/FuseLstatReturnMtimeTest.cpp
    fuse/lstat/FuseLstatReturnSizeTest.cpp
    fuse/read/FuseReadFileDescriptorTest.cpp
    fuse/read/testutils/FuseReadTest.cpp
    fuse/read/FuseReadOverflowTest.cpp
    fuse/read/FuseReadErrorTest.cpp
    fuse/read/FuseReadReturnedDataTest.cpp
    fuse/flush/testutils/FuseFlushTest.cpp
    fuse/flush/FuseFlushErrorTest.cpp
    fuse/flush/FuseFlushFileDescriptorTest.cpp
    fuse/rename/testutils/FuseRenameTest.cpp
    fuse/rename/FuseRenameErrorTest.cpp
    fuse/rename/FuseRenameFilenameTest.cpp
    fuse/utimens/testutils/FuseUtimensTest.cpp
    fuse/utimens/FuseUtimensErrorTest.cpp
    fuse/utimens/FuseUtimensFilenameTest.cpp
    fuse/utimens/FuseUtimensTimeParameterTest.cpp
    fuse/unlink/testutils/FuseUnlinkTest.cpp
    fuse/unlink/FuseUnlinkErrorTest.cpp
    fuse/unlink/FuseUnlinkFilenameTest.cpp
    fuse/ftruncate/testutils/FuseFTruncateTest.cpp
    fuse/ftruncate/FuseFTruncateFileDescriptorTest.cpp
    fuse/ftruncate/FuseFTruncateSizeTest.cpp
    fuse/ftruncate/FuseFTruncateErrorTest.cpp
    fuse/fstat/testutils/FuseFstatTest.cpp
    fuse/fstat/FuseFstatParameterTest.cpp
    fuse/fstat/FuseFstatErrorTest.cpp
    fuse/truncate/FuseTruncateSizeTest.cpp
    fuse/truncate/testutils/FuseTruncateTest.cpp
    fuse/truncate/FuseTruncateErrorTest.cpp
    fuse/truncate/FuseTruncateFilenameTest.cpp
    fuse/statfs/FuseStatfsReturnFilesTest.cpp
    fuse/statfs/FuseStatfsReturnFfreeTest.cpp
    fuse/statfs/FuseStatfsReturnNamemaxTest.cpp
    fuse/statfs/testutils/FuseStatfsTest.cpp
    fuse/statfs/FuseStatfsReturnBsizeTest.cpp
    fuse/statfs/FuseStatfsErrorTest.cpp
    fuse/statfs/FuseStatfsReturnBfreeTest.cpp
    fuse/statfs/FuseStatfsReturnBlocksTest.cpp
    fuse/statfs/FuseStatfsReturnBavailTest.cpp
    fuse/closeFile/FuseCloseTest.cpp
    fuse/fsync/testutils/FuseFsyncTest.cpp
    fuse/fsync/FuseFsyncFileDescriptorTest.cpp
    fuse/fsync/FuseFsyncErrorTest.cpp
    fuse/openFile/testutils/FuseOpenTest.cpp
    fuse/openFile/FuseOpenFilenameTest.cpp
    fuse/openFile/FuseOpenFlagsTest.cpp
    fuse/openFile/FuseOpenFileDescriptorTest.cpp
    fuse/openFile/FuseOpenErrorTest.cpp
    fuse/access/FuseAccessFilenameTest.cpp
    fuse/access/testutils/FuseAccessTest.cpp
    fuse/access/FuseAccessModeTest.cpp
    fuse/access/FuseAccessErrorTest.cpp
    fuse/BasicFuseTest.cpp
    fuse/TimestampTest.cpp
    fuse/rmdir/testutils/FuseRmdirTest.cpp
    fuse/rmdir/FuseRmdirErrorTest.cpp
    fuse/rmdir/FuseRmdirDirnameTest.cpp
    fuse/fdatasync/testutils/FuseFdatasyncTest.cpp
    fuse/fdatasync/FuseFdatasyncErrorTest.cpp
    fuse/fdatasync/FuseFdatasyncFileDescriptorTest.cpp
    fuse/mkdir/testutils/FuseMkdirTest.cpp
    fuse/mkdir/FuseMkdirErrorTest.cpp
    fuse/mkdir/FuseMkdirModeTest.cpp
    fuse/mkdir/FuseMkdirDirnameTest.cpp
    fuse/write/FuseWriteErrorTest.cpp
    fuse/write/testutils/FuseWriteTest.cpp
    fuse/write/FuseWriteOverflowTest.cpp
    fuse/write/FuseWriteFileDescriptorTest.cpp
    fuse/write/FuseWriteDataTest.cpp
    fuse/readDir/testutils/FuseReadDirTest.cpp
    fuse/readDir/FuseReadDirDirnameTest.cpp
    fuse/readDir/FuseReadDirErrorTest.cpp
    fuse/readDir/FuseReadDirReturnTest.cpp
    fuse/createAndOpenFile/FuseCreateAndOpenFilenameTest.cpp
    fuse/createAndOpenFile/testutils/FuseCreateAndOpenTest.cpp
    fuse/createAndOpenFile/FuseCreateAndOpenFlagsTest.cpp
    fuse/createAndOpenFile/FuseCreateAndOpenFileDescriptorTest.cpp
    fuse/createAndOpenFile/FuseCreateAndOpenErrorTest.cpp
    fuse/FilesystemTest.cpp
    fs_interface/NodeTest.cpp
    fs_interface/FileTest.cpp
    fs_interface/DirTest.cpp
    fs_interface/DeviceTest.cpp
    fs_interface/OpenFileTest.cpp
        testutils/OpenFileHandle.cpp testutils/OpenFileHandle.h)

add_executable(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} my-gtest-main googletest fspp-interface fspp-fuse)
add_test(${PROJECT_NAME} ${PROJECT_NAME})

target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== googletest/CMakeLists.txt ===
include(CTest)

if (BUILD_TESTING)
  # Fix how gtest links the C library on windows, see https://github.com/google/googletest/blob/4e4df226fc197c0dda6e37f5c8c3845ca1e73a49/googletest/README.md
  set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
  set(INSTALL_GTEST off CACHE BOOL "" FORCE)
  set(INSTALL_GMOCK off CACHE BOOL "" FORCE)
  add_subdirectory(gtest EXCLUDE_FROM_ALL)
  
  add_library(googletest INTERFACE)
  target_link_libraries(googletest INTERFACE gtest gmock)
  target_include_directories(googletest SYSTEM INTERFACE ${gtest_INCLUDE_DIRS}/include SYSTEM INTERFACE ${gmock_INCLUDE_DIRS}/include)
endif()

=== parallelaccessstore/CMakeLists.txt ===
project (parallelaccessstore-test)

set(SOURCES
    ParallelAccessBaseStoreTest.cpp
    DummyTest.cpp
)

add_executable(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} my-gtest-main googletest parallelaccessstore)
add_test(${PROJECT_NAME} ${PROJECT_NAME})

target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== cryptopp/vendor_cryptopp/CMakeLists.txt ===
# Please ensure your changes or patch meets minimum requirements.
#   The minimum requirements are 2.8.6. It roughly equates to
#   Ubuntu 14.05 LTS or Solaris 11.3. Please do not check in something
#   for 3.5.0 or higher because it will break LTS operating systems
#   and a number of developer boards used for testing. To test your
#   changes, please set up a Ubuntu 14.05 LTS system.

# Should we be setting things like this? We are not a C project
# so nothing should be done with the C compiler. But there is
# no reliable way to tell CMake we are C++.
# Cannot set this... Breaks Linux PowerPC with Clang:
# SET(CMAKE_C_COMPILER ${CMAKE_CXX_COMPILER})
# # error "The CMAKE_C_COMPILER is set to a C++ compiler"

if(NOT DEFINED cryptopp_DISPLAY_CMAKE_SUPPORT_WARNING)
  set(cryptopp_DISPLAY_CMAKE_SUPPORT_WARNING 1)
endif()
if(cryptopp_DISPLAY_CMAKE_SUPPORT_WARNING)
  message( STATUS
"*************************************************************************\n"
"The Crypto++ library does not officially support CMake. CMake support is a\n"
"community effort, and the library works with the folks using CMake to help\n"
"improve it. If you find an issue then please fix it or report it at\n"
"https://github.com/noloader/cryptopp-cmake.\n"
"-- *************************************************************************"
)
endif()

# Print useful information
message( STATUS "CMake version ${CMAKE_VERSION}" )
message( STATUS "System ${CMAKE_SYSTEM_NAME}" )
message( STATUS "Processor ${CMAKE_SYSTEM_PROCESSOR}" )

cmake_minimum_required(VERSION 2.8.6)
cmake_policy(SET CMP0069 NEW)
if (${CMAKE_VERSION} VERSION_LESS "3.0.0")
  project(cryptopp)
  set(cryptopp_VERSION_MAJOR 8)
  set(cryptopp_VERSION_MINOR 6)
  set(cryptopp_VERSION_PATCH 0)
else ()
  cmake_policy(SET CMP0048 NEW)
  project(cryptopp VERSION 8.6.0)
  if (NOT ${CMAKE_VERSION} VERSION_LESS "3.1.0")
    cmake_policy(SET CMP0054 NEW)
  endif ()
endif ()

# Need to set SRC_DIR manually after removing the Python library code.
set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR})

# Make RelWithDebInfo the default (it does e.g. add '-O2 -g -DNDEBUG' for GNU)
#   If not in multi-configuration environments, no explicit build type or CXX
#   flags are set by the user and if we are the root CMakeLists.txt file.
if (NOT CMAKE_CONFIGURATION_TYPES AND
    NOT CMAKE_NO_BUILD_TYPE AND
    NOT CMAKE_BUILD_TYPE AND
    NOT CMAKE_CXX_FLAGS AND
    CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif ()

include(GNUInstallDirs)
include(CheckCXXCompilerFlag)

# We now carry around test programs. test_cxx.cpp is the default C++ one.
# Also see https://github.com/weidai11/cryptopp/issues/741.
set(TEST_PROG_DIR ${SRC_DIR}/TestPrograms)
set(TEST_CXX_FILE ${TEST_PROG_DIR}/test_cxx.cpp)

#============================================================================
# Settable options
#============================================================================

option(BUILD_STATIC "Build static library" ON)
option(BUILD_SHARED "Build shared library" ON)
option(CRYPTOPP_BUILD_TESTING "Build library tests" ON)
option(BUILD_DOCUMENTATION "Use Doxygen to create the HTML based API documentation" OFF)
option(USE_INTERMEDIATE_OBJECTS_TARGET "Use a common intermediate objects target for the static and shared library targets" ON)

if (${CMAKE_VERSION} VERSION_GREATER "3.1")
  option(USE_OPENMP "Enable OpenMP to parallelize some of the algorithms. Note that this isn't always faster, see https://www.cryptopp.com/wiki/OpenMP" OFF)
endif()


# These are IA-32 options.
option(DISABLE_ASM "Disable ASM" OFF)
option(DISABLE_SSSE3 "Disable SSSE3" OFF)
option(DISABLE_SSE4 "Disable SSE4" OFF)
option(DISABLE_AESNI "Disable AES-NI" OFF)
option(DISABLE_CLMUL "Disable CLMUL" OFF)
option(DISABLE_SHA "Disable SHA" OFF)
option(DISABLE_AVX "Disable AVX" OFF)
option(DISABLE_AVX2 "Disable AVX2" OFF)

# These are ARM A-32 options
option(DISABLE_ARM_NEON "Disable NEON" OFF)

# These are Aarch64 options
option(DISABLE_ARM_AES "Disable ASIMD" OFF)
option(DISABLE_ARM_AES "Disable AES" OFF)
option(DISABLE_ARM_PMULL "Disable PMULL" OFF)
option(DISABLE_ARM_SHA "Disable SHA" OFF)

# These are PowerPC options
option(DISABLE_ALTIVEC "Disable Altivec" OFF)
option(DISABLE_POWER7 "Disable POWER7" OFF)
option(DISABLE_POWER8 "Disable POWER8" OFF)
option(DISABLE_POWER9 "Disable POWER9" OFF)

set(CRYPTOPP_DATA_DIR "" CACHE PATH "Crypto++ test data directory")

#============================================================================
# Compiler options
#============================================================================

set(CRYPTOPP_COMPILE_DEFINITIONS)
set(CRYPTOPP_COMPILE_OPTIONS)

# Stop hiding the damn output...
# set(CMAKE_VERBOSE_MAKEFILE ON)

# Stop CMake complaining...
if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  set(MACOSX_RPATH FALSE)
endif()

# Always 1 ahead in Master. Also see http://groups.google.com/forum/#!topic/cryptopp-users/SFhqLDTQPG4
set(LIB_VER ${cryptopp_VERSION_MAJOR}${cryptopp_VERSION_MINOR}${cryptopp_VERSION_PATCH})

if (CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
  list(APPEND CRYPTOPP_COMPILE_OPTIONS -wd68 -wd186 -wd279 -wd327 -wd161 -wd3180)
endif ()

# Also see http://github.com/weidai11/cryptopp/issues/395
if (DISABLE_ASM)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_ASM)
endif ()
if (DISABLE_SSSE3)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_SSSE3)
endif ()
if (DISABLE_SSE4)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_SSSE4)
endif ()
if (DISABLE_CLMUL)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_CLMUL)
endif ()
if (DISABLE_AESNI)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_AESNI)
endif ()
if (DISABLE_RDRAND)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_RDRAND)
endif ()
if (DISABLE_RDSEED)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_RDSEED)
endif ()
if (DISABLE_AVX)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_AVX)
endif ()
if (DISABLE_AVX2)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_AVX2)
endif ()
if (DISABLE_SHA)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_SHA)
endif ()
if (DISABLE_ARM_NEON)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_ARM_NEON)
endif ()
if (DISABLE_ARM_ASIMD)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_ARM_ASIMD)
endif ()
if (DISABLE_ARM_AES)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_ARM_AES)
endif ()
if (DISABLE_ARM_PMULL)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_ARM_PMULL)
endif ()
if (DISABLE_ARM_SHA)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_ARM_SHA)
endif ()
if (DISABLE_ALTIVEC)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_ALTIVEC)
endif ()
if (DISABLE_POWER7)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_POWER7)
endif ()
if (DISABLE_POWER8)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_POWER8)
endif ()
if (DISABLE_POWER9)
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS CRYPTOPP_DISABLE_POWER9)
endif ()
if (NOT CRYPTOPP_DATA_DIR STREQUAL "")
  list(APPEND CRYPTOPP_COMPILE_DEFINITIONS "CRYPTOPP_DATA_DIR=${CRYPTOPP_DATA_DIR}")
endif ()

###############################################################################

# Try to find a Posix compatible grep and sed. Solaris, Digital Unix,
#   Tru64, HP-UX and a few others need tweaking

if (EXISTS /usr/xpg4/bin/grep)
  set(GREP_CMD /usr/xpg4/bin/grep)
elseif (EXISTS /usr/gnu/bin/grep)
  set(GREP_CMD /usr/gnu/bin/grep)
elseif (EXISTS /usr/linux/bin/grep)
  set(GREP_CMD /usr/linux/bin/grep)
else ()
  set(GREP_CMD grep)
endif ()

if (EXISTS /usr/xpg4/bin/sed)
  set(SED_CMD /usr/xpg4/bin/sed)
elseif (EXISTS /usr/gnu/bin/sed)
  set(SED_CMD /usr/gnu/bin/sed)
elseif (EXISTS /usr/linux/bin/sed)
  set(SED_CMD /usr/linux/bin/sed)
else ()
  set(SED_CMD sed)
endif ()

###############################################################################

function(CheckCompileOption opt var)

  if (MSVC)

    # TODO: improve this...
    CHECK_CXX_COMPILER_FLAG(${opt} ${var})

  elseif (CMAKE_CXX_COMPILER_ID MATCHES "SunPro")

    message(STATUS "Performing Test ${var}")
    execute_process(
      COMMAND sh -c "${CMAKE_CXX_COMPILER} ${CMAKE_CXX_FLAGS} ${opt} -c ${TEST_CXX_FILE} 2>&1"
      COMMAND ${GREP_CMD} -i -c -E "illegal value ignored"
      RESULT_VARIABLE COMMAND_RESULT
      OUTPUT_VARIABLE COMMAND_OUTPUT
      OUTPUT_STRIP_TRAILING_WHITESPACE)

    # No dereference below. Thanks for the warning, CMake (not!).
    if (COMMAND_RESULT AND NOT COMMAND_OUTPUT)
      set(${var} 1 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Success")
    else ()
      set(${var} 0 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Failed")
    endif ()

  # Must use CMAKE_CXX_COMPILER here due to XLC 13.1 and LLVM front-end.
  elseif (CMAKE_CXX_COMPILER MATCHES "xlC")

    message(STATUS "Performing Test ${var}")
    execute_process(
      COMMAND sh -c "${CMAKE_CXX_COMPILER} ${CMAKE_CXX_FLAGS} ${opt} -c ${TEST_CXX_FILE} 2>&1"
      COMMAND ${GREP_CMD} -i -c -E "Unrecognized value"
      RESULT_VARIABLE COMMAND_RESULT
      OUTPUT_VARIABLE COMMAND_OUTPUT
      OUTPUT_STRIP_TRAILING_WHITESPACE)

    # No dereference below. Thanks for the warning, CMake (not!).
    if (COMMAND_RESULT AND NOT COMMAND_OUTPUT)
      set(${var} 1 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Success")
    else ()
      set(${var} 0 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Failed")
    endif ()

  else ()

    CHECK_CXX_COMPILER_FLAG(${opt} ${var})

  endif ()

endfunction(CheckCompileOption)

function(CheckCompileLinkOption opt var prog)

  if (MSVC)

    # TODO: improve this...
    CHECK_CXX_COMPILER_FLAG(${opt} ${var})

  elseif (APPLE)

    message(STATUS "Performing Test ${var}")
    try_compile(COMMAND_SUCCESS ${CMAKE_BINARY_DIR} ${prog} COMPILE_DEFINITIONS ${opt})
    if (COMMAND_SUCCESS)
      set(${var} 1 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Success")
    else ()
      set(${var} 0 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Failed")
    endif ()

  else ()

    message(STATUS "Performing Test ${var}")
    try_compile(COMMAND_SUCCESS ${CMAKE_BINARY_DIR} ${prog} COMPILE_DEFINITIONS ${opt})
    if (COMMAND_SUCCESS)
        set(${var} 1 PARENT_SCOPE)
        message(STATUS "Performing Test ${var} - Success")
    else ()
      set(${var} 0 PARENT_SCOPE)
      message(STATUS "Performing Test ${var} - Failed")
    endif ()

  endif ()

endfunction(CheckCompileLinkOption)

function(AddCompileOption opt)

    if ("${COMMAND_OUTPUT}" NOT STREQUAL "")
      list(APPEND CRYPTOPP_COMPILE_OPTIONS "${opt}")
    endif ()

endfunction(AddCompileOption)

###############################################################################

function(DumpMachine output pattern)

  if (MSVC)

    # CMake does not provide a generic shell/terminal mechanism
    #  and Microsoft environments don't know what 'sh' is.
    set(${output} 0 PARENT_SCOPE)

  else ()
      if(CMAKE_SYSTEM_PROCESSOR MATCHES ${pattern})
          set(${output} TRUE PARENT_SCOPE)
      endif()
  endif()

endfunction(DumpMachine)

# Thanks to Anonimal for MinGW; see http://github.com/weidai11/cryptopp/issues/466
DumpMachine(CRYPTOPP_AMD64 "(x86_64|AMD64|amd64)")
DumpMachine(CRYPTOPP_I386 "^i.86$")
DumpMachine(CRYPTOPP_MINGW32 "^mingw32")
DumpMachine(CRYPTOPP_MINGW64 "(w64-mingw32|mingw64)")
DumpMachine(CRYPTOPP_ARMV8 "(armv8|arm64|aarch32|aarch64)")
DumpMachine(CRYPTOPP_ARM32 "(arm|armhf|arm7l|eabihf)")
DumpMachine(CRYPTOPP_PPC32 "^(powerpc|ppc)")
DumpMachine(CRYPTOPP_PPC64 "^ppc64")

# Cleanup 32/64 bit
if (CRYPTOPP_AMD64)
  set (CRYPTOPP_I386 0)
endif ()

if (CRYPTOPP_ARMV8)
  set (CRYPTOPP_ARM32 0)
endif ()

if (CRYPTOPP_PPC64)
  set (CRYPTOPP_PPC32 0)
endif ()


###############################################################################

=== fspp/fs_interface/CMakeLists.txt ===
project (fspp-interface)

set(SOURCES
  Device.cpp
  Dir.cpp
  File.cpp
  Node.cpp
  OpenFile.cpp
  Symlink.cpp
  Types.cpp
  Context.cpp
)

add_library(${PROJECT_NAME} STATIC ${SOURCES})

target_link_libraries(${PROJECT_NAME} PUBLIC cpp-utils)

target_add_boost(${PROJECT_NAME})
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== debian/changelog ===
cryfs (0.11.3-5) unstable; urgency=medium

  * Re-upload with proper distribution.

 -- David Steele <steele@debian.org>  Wed, 28 Dec 2022 09:05:41 -0500

cryfs (0.11.3-4) jammy; urgency=medium

  * Disable asm on s390x build

 -- David Steele <steele@debian.org>  Tue, 27 Dec 2022 16:25:41 -0500

cryfs (0.11.3-3) unstable; urgency=medium

  * Revert NEWS.

 -- David Steele <steele@debian.org>  Thu, 03 Nov 2022 22:23:44 -0400

cryfs (0.11.3-2) unstable; urgency=medium

  * Add NEWS warning.

 -- David Steele <steele@debian.org>  Thu, 03 Nov 2022 22:12:58 -0400

cryfs (0.11.3-1) unstable; urgency=medium

  * New upstream version.
  * Add cryfs-unmount to package (Closes: #1008845, #1017721).

 -- David Steele <steele@debian.org>  Thu, 03 Nov 2022 17:50:53 -0400

=== debian/control ===
Source: cryfs
Maintainer: David Steele <steele@debian.org>
Section: utils
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               pkg-config,
               librange-v3-dev,
               libspdlog-dev,
               libcurl4-openssl-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-chrono-dev,
               libboost-program-options-dev,
               libboost-thread-dev,
               libcrypto++-dev (>= 5.6.4),
               libssl-dev,
               libfuse-dev,
               python3-all,
Rules-Requires-Root: no
Standards-Version: 4.6.0.1
Vcs-Browser: https://github.com/davesteele/cryfs
Vcs-Git: https://github.com/davesteele/cryfs.git -b debian
Homepage: https://www.cryfs.org/

Package: cryfs
Architecture: linux-any
Depends: fuse,
         ${misc:Depends},
         ${shlibs:Depends}
Description: encrypt your files and store them in the cloud
 CryFS encrypts your files, so you can safely store them anywhere. It works
 well together with cloud services like Dropbox, iCloud, OneDrive and others.

## cryfs 0.11.4

=== CMakeLists.txt ===
# appends a build number from the APPVEYOR_BUILD_NUMBER environment variable as fourth component to a version number,
# i.e. "0.10" becomes "0.10.0.[buildnumber]", "1" becomes "1.0.0.[buildnumber]".
function(append_build_number VERSION_NUMBER OUTPUT)
	string(REPLACE "." ";" VERSION_COMPONENTS ${STRIPPED_VERSION_NUMBER})
	list(LENGTH VERSION_COMPONENTS NUM_VERSION_COMPONENTS)
	if (${NUM_VERSION_COMPONENTS} LESS_EQUAL 0)
		message(FATAL_ERROR "Didn't find any version components")
	endif()
	if (${NUM_VERSION_COMPONENTS} LESS_EQUAL 1)
		string(APPEND STRIPPED_VERSION_NUMBER ".0")
	endif()
	if (${NUM_VERSION_COMPONENTS} LESS_EQUAL 2)
		string(APPEND STRIPPED_VERSION_NUMBER ".0")
	endif()
	if (NOT $ENV{APPVEYOR_BUILD_NUMBER} STREQUAL "")
		string(APPEND STRIPPED_VERSION_NUMBER ".$ENV{APPVEYOR_BUILD_NUMBER}")
	endif()
	set(${OUTPUT} "${STRIPPED_VERSION_NUMBER}" PARENT_SCOPE)
endfunction()

if("${CMAKE_VERSION}" VERSION_LESS "3.3")
    # Earlier cmake versions generate .deb packages for which the package manager says they're bad quality
    # and asks the user whether they really want to install it. Cmake 3.3 fixes this.
    message(WARNING "Distribution package generation is only supported for CMake version >= 3.3. You're using ${CMAKE_VERSION}. You will be able to build and install CryFS, but you won't be able to generate .deb packages.")
else()
    # Fix debfiles permissions. Unfortunately, git doesn't store file permissions.
    # When installing the .deb package and these files have the wrong permissions, the package manager complains.
    execute_process(COMMAND /bin/bash -c "chmod 0755 ${CMAKE_CURRENT_SOURCE_DIR}/debfiles/*")

    set(CPACK_PACKAGE_NAME "cryfs")
    set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Encrypt your files and store them in the cloud.")
    set(CPACK_PACKAGE_DESCRIPTION "CryFS encrypts your files, so you can safely store them anywhere. It works well together with cloud services like Dropbox, iCloud, OneDrive and others.")
    set(CPACK_PACKAGE_CONTACT "Sebastian Messmer <messmer@cryfs.org>")
    set(CPACK_PACKAGE_VENDOR "Sebastian Messmer")
    set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../LICENSE.txt")

    get_git_version(GITVERSION_VERSION_STRING)

    if(WIN32 AND NOT UNIX)
        set(CPACK_GENERATOR WIX)

        string(REGEX REPLACE "^([0-9\\.]+)([-+][0-9\\.a-zA-Z+-]+)?$" "\\1" STRIPPED_VERSION_NUMBER "${GITVERSION_VERSION_STRING}")
        append_build_number(${STRIPPED_VERSION_NUMBER} WIX_VERSION_NUMBER)
        message(STATUS "WIX package version is ${WIX_VERSION_NUMBER}")
        set(CPACK_PACKAGE_VERSION "${WIX_VERSION_NUMBER}")

        set(CPACK_WIX_UPGRADE_GUID "8b872ce1-557d-48e6-ac57-9f5e574feabf")
        set(CPACK_WIX_PRODUCT_GUID "26116061-4f99-4c44-a178-2153fa396308")
        #set(CPACK_WIX_PRODUCT_ICON "...")
        set(CPACK_WIX_PROPERTY_ARPURLINFOABOUT "https://www.cryfs.org")
        set(CPACK_PACKAGE_INSTALL_DIRECTORY "CryFS/${GITVERSION_VERSION_STRING}")
        set(CPACK_WIX_PATCH_FILE "${CMAKE_CURRENT_SOURCE_DIR}/wix/change_path_env.xml")
    else()
        set(CPACK_GENERATOR TGZ DEB RPM)
        set(CPACK_PACKAGE_VERSION "${GITVERSION_VERSION_STRING}")
        set(CPACK_STRIP_FILES OFF)
        set(CPACK_SOURCE_STRIP_FILES OFF)
    endif()
    set(CPACK_PACKAGE_EXECUTABLES "cryfs" "CryFS")
    set(CPACK_DEBIAN_PACKAGE_SECTION "utils")
    set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
    # Needs gnupg2, lsb-release for postinst script
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "fuse, gnupg2, lsb-release")

    set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://www.cryfs.org")
    set(CPACK_RPM_PACKAGE_LICENSE "LGPLv3")
    set(CPACK_RPM_PACKAGE_DESCRIPTION ${CPACK_PACKAGE_DESCRIPTION})
    set(CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION "/usr/bin;/usr/share/man;/usr/share/man/man1")
    set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA "${CMAKE_CURRENT_SOURCE_DIR}/debfiles/postinst;${CMAKE_CURRENT_SOURCE_DIR}/debfiles/postrm")

    include(CPack)
endif()

=== cpp-utils/CMakeLists.txt ===
project (cpp-utils)

set(SOURCES
        crypto/symmetric/ciphers.cpp
        crypto/symmetric/testutils/FakeAuthenticatedCipher.cpp
        crypto/kdf/Scrypt.cpp
        crypto/kdf/SCryptParameters.cpp
        crypto/kdf/PasswordBasedKDF.cpp
        crypto/RandomPadding.cpp
        crypto/symmetric/EncryptionKey.cpp
        crypto/hash/Hash.cpp
        process/daemonize.cpp
        process/subprocess.cpp
        process/SignalCatcher.cpp
        process/SignalHandler.cpp
        tempfile/TempFile.cpp
        tempfile/TempDir.cpp
        network/HttpClient.cpp
        network/CurlHttpClient.cpp
		network/WinHttpClient.cpp
        network/FakeHttpClient.cpp
        io/Console.cpp
        io/DontEchoStdinToStdoutRAII.cpp
        io/IOStreamConsole.cpp
        io/NoninteractiveConsole.cpp
        io/pipestream.cpp
        io/ProgressBar.cpp
        thread/LoopThread.cpp
        thread/ThreadSystem.cpp
        thread/debugging_nonwindows.cpp
        thread/debugging_windows.cpp
        thread/LeftRight.cpp
        random/Random.cpp
        random/RandomGeneratorThread.cpp
        random/OSRandomGenerator.cpp
        random/PseudoRandomPool.cpp
        random/RandomDataBuffer.cpp
        random/RandomGenerator.cpp
        lock/LockPool.cpp
        data/SerializationHelper.cpp
        data/Serializer.cpp
        data/Deserializer.cpp
        data/DataFixture.cpp
        data/DataUtils.cpp
        data/Data.cpp
        assert/assert.cpp
        assert/backtrace_nonwindows.cpp
        assert/backtrace_windows.cpp
        assert/AssertFailed.cpp
        system/get_total_memory.cpp
        system/homedir.cpp
        system/memory_nonwindows.cpp
        system/memory_windows.cpp
        system/time.cpp
		system/diskspace.cpp
		system/filetime_nonwindows.cpp
		system/filetime_windows.cpp
		system/env.cpp
        value_type/ValueType.cpp
)

add_library(${PROJECT_NAME} STATIC ${SOURCES})

if(MSVC)
    target_link_libraries(${PROJECT_NAME} PUBLIC DbgHelp)
elseif (APPLE)
    target_compile_definitions(${PROJECT_NAME} PRIVATE BOOST_STACKTRACE_GNU_SOURCE_NOT_REQUIRED)
else()
    find_program(ADDR2LINE addr2line)
    if ("${ADDR2LINE}" STREQUAL "ADDR2LINE-NOTFOUND")
        message(WARNING "addr2line not found. Backtraces will be reduced.")
    else()
        message(STATUS "addr2line found. Using it for backtraces.")
        target_compile_definitions(${PROJECT_NAME} PRIVATE BOOST_STACKTRACE_USE_ADDR2LINE)
        target_compile_definitions(${PROJECT_NAME} PRIVATE BOOST_STACKTRACE_ADDR2LINE_LOCATION=${ADDR2LINE})
    endif()
endif()

if (NOT MSVC)
  find_package(CURL REQUIRED)
  target_include_directories(${PROJECT_NAME} PUBLIC ${CURL_INCLUDE_DIRS})
  target_link_libraries(${PROJECT_NAME} PUBLIC ${CURL_LIBRARIES})
else()
  target_link_libraries(${PROJECT_NAME} PUBLIC WinHttp)
endif()

find_package(Threads REQUIRED)
target_link_libraries(${PROJECT_NAME} PUBLIC ${CMAKE_THREAD_LIBS_INIT})

target_link_libraries(${PROJECT_NAME} PUBLIC ${CMAKE_DL_LIBS})

target_link_libraries(${PROJECT_NAME} PUBLIC CryfsDependencies_spdlog cryptopp CryfsDependencies_range-v3)

target_add_boost(${PROJECT_NAME})
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

if(MSVC)
    # Required by range-v3, see its README.md
    target_compile_options(${PROJECT_NAME} PUBLIC /experimental:preprocessor /permissive- /Zc:twoPhase-)
endif()

=== cryfs-cli/CMakeLists.txt ===
project (cryfs-cli)
INCLUDE(GNUInstallDirs)

set(SOURCES
        Cli.cpp
        VersionChecker.cpp
        CallAfterTimeout.cpp
        Environment.cpp
        program_options/utils.cpp
        program_options/ProgramOptions.cpp
        program_options/Parser.cpp
)

add_library(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} PUBLIC cryfs cpp-utils gitversion fspp-fuse)
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

if(NOT CRYFS_UPDATE_CHECKS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE -DCRYFS_NO_UPDATE_CHECKS)
endif(NOT CRYFS_UPDATE_CHECKS)

add_executable(${PROJECT_NAME}_bin main.cpp)
set_target_properties(${PROJECT_NAME}_bin PROPERTIES OUTPUT_NAME cryfs)
target_link_libraries(${PROJECT_NAME}_bin PUBLIC ${PROJECT_NAME})
target_enable_style_warnings(${PROJECT_NAME}_bin)
target_activate_cpp14(${PROJECT_NAME}_bin)

install(TARGETS ${PROJECT_NAME}_bin
        DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== cryfs/CMakeLists.txt ===
project (cryfs-test)

set(SOURCES
        impl/config/crypto/CryConfigEncryptorFactoryTest.cpp
        impl/config/crypto/outer/OuterConfigTest.cpp
        impl/config/crypto/outer/OuterEncryptorTest.cpp
        impl/config/crypto/inner/ConcreteInnerEncryptorTest.cpp
        impl/config/crypto/inner/InnerConfigTest.cpp
        impl/config/crypto/CryConfigEncryptorTest.cpp
        impl/config/CompatibilityTest.cpp
        impl/config/CryConfigCreatorTest.cpp
        impl/config/CryConfigFileTest.cpp
        impl/config/CryConfigTest.cpp
        impl/config/CryCipherTest.cpp
        impl/config/CryConfigLoaderTest.cpp
        impl/config/CryConfigConsoleTest.cpp
        impl/config/CryPasswordBasedKeyProviderTest.cpp
        impl/config/CryPresetPasswordBasedKeyProviderTest.cpp
        impl/filesystem/CryFsTest.cpp
        impl/filesystem/CryNodeTest.cpp
        impl/filesystem/FileSystemTest.cpp
        impl/localstate/LocalStateMetadataTest.cpp
        impl/localstate/BasedirMetadataTest.cpp
)

add_executable(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} my-gtest-main googletest cryfs)
add_test(${PROJECT_NAME} ${PROJECT_NAME})

target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

=== cryptopp/CMakeLists.txt ===
project(mycryptopp)

add_library(cryptopp INTERFACE)
# note: include directory is called vendor_cryptopp instead of cryptopp to avoid include clashes with system headers
target_include_directories(cryptopp SYSTEM INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})

# Forward debug build info (i.e. set CRYPTOPP_DEBUG variable if building in debug mode)
target_compile_definitions(cryptopp INTERFACE $<$<CONFIG:Debug>:CRYPTOPP_DEBUG>) # add to all targets depending on this
add_compile_options($<$<CONFIG:Debug>:-DCRYPTOPP_DEBUG>) # add to stuff built in subdirectories (like the actual library)

if (NOT DISABLE_OPENMP)
    set(USE_OPENMP ON CACHE BOOL "")
endif()
set(CRYPTOPP_BUILD_TESTING OFF CACHE BOOL "")
set(BUILD_DOCUMENTATION OFF CACHE BOOL "")
set(BUILD_SHARED OFF CACHE BOOL "")
set(BUILD_STATIC ON CACHE BOOL "")
set(USE_INTERMEDIATE_OBJECTS_TARGET OFF CACHE BOOL "")
set(cryptocpp_DISPLAY_CMAKE_SUPPORT_WARNING OFF CACHE BOOL "")
add_subdirectory(vendor_cryptopp EXCLUDE_FROM_ALL)

target_link_libraries(cryptopp INTERFACE cryptopp-static)

=== stats/CMakeLists.txt ===
project (stats)

set(SOURCES
        main.cpp
        traversal.cpp
)

add_executable(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} PUBLIC cryfs cpp-utils gitversion)
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})
set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME cryfs-stats)

=== fspp/fuse/CMakeLists.txt ===
project (fspp-fuse)

set(SOURCES
  ../impl/FilesystemImpl.cpp
  ../impl/Profiler.cpp
  ../fuse/Fuse.cpp
)

add_library(${PROJECT_NAME} STATIC ${SOURCES})

target_compile_definitions(${PROJECT_NAME} PUBLIC _FILE_OFFSET_BITS=64)
target_link_libraries(${PROJECT_NAME} PUBLIC cpp-utils fspp-interface)

target_add_boost(${PROJECT_NAME})
target_enable_style_warnings(${PROJECT_NAME})
target_activate_cpp14(${PROJECT_NAME})

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  get_target_architecture(TARGET_ARCH)
  message(STATUS "Linking to Dokan ${TARGET_ARCH}")
  if ("${TARGET_ARCH}" STREQUAL "x86_64")
	set(DOKAN_LIB_PATH "${DOKAN_PATH}")
  elseif("${TARGET_ARCH}" STREQUAL "i386")
    set(DOKAN_LIB_PATH "${DOKAN_PATH}/x86")
  else()
    message(FATAL_ERROR "Unsupported architecture: ${TARGET_ARCH}")
  endif()

  target_include_directories(${PROJECT_NAME} PUBLIC "${DOKAN_PATH}/include")
  target_link_libraries(${PROJECT_NAME} PUBLIC "${DOKAN_LIB_PATH}/lib/dokan1.lib")
  #target_link_libraries(${PROJECT_NAME} PUBLIC "${DOKAN_LIB_PATH}/lib/dokannp1.lib")
  target_link_libraries(${PROJECT_NAME} PUBLIC "${DOKAN_LIB_PATH}/lib/dokanfuse1.lib")

  install(FILES "${DOKAN_LIB_PATH}/dokan1.dll" "${DOKAN_LIB_PATH}/dokanfuse1.dll"
    DESTINATION "${CMAKE_INSTALL_BINDIR}"
  )

else() # Linux and macOS
  find_package(PkgConfig REQUIRED)
  pkg_check_modules(Fuse REQUIRED IMPORTED_TARGET fuse)
  target_link_libraries(${PROJECT_NAME} PUBLIC PkgConfig::Fuse)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set(CMAKE_FIND_FRAMEWORK LAST)
endif()

=== debian/changelog ===
cryfs (0.11.4-5) unstable; urgency=medium

  * QA upload.
  * Build using the default gcc. (Closes: #1114085)
  * Backport upstream fix for FTBFS with CMake 4. (Closes: #1112816)
  * Use the system libcrypto++. (Closes: #1108008)
  * Use the system GoogleTest.
  * Apply patch from Aurelien Jarno to enable parallel building and
    fix nocheck. (Closes: #1086870)

 -- Adrian Bunk <bunk@debian.org>  Sat, 06 Sep 2025 22:04:23 +0300

cryfs (0.11.4-4) unstable; urgency=medium

  * Orphaning - Set Maintainer to Debian QA.

 -- David Steele <steele@debian.org>  Sat, 06 Sep 2025 10:45:52 -0400

cryfs (0.11.4-3) unstable; urgency=medium

  * Move Debian hosting home to Salsa.

 -- David Steele <steele@debian.org>  Fri, 17 Jan 2025 12:57:32 -0500

cryfs (0.11.4-2) unstable; urgency=medium

  * Upgrade build to gcc version 14.

 -- David Steele <steele@debian.org>  Sat, 17 Aug 2024 22:45:55 -0400

cryfs (0.11.4-1) unstable; urgency=medium

  * New upstream version.
  * Fix gcc-13 compile problem (Closes: #1037612)

 -- David Steele <steele@debian.org>  Thu, 20 Jul 2023 15:27:59 -0400

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: cryfs
-Maintainer: David Steele <steele@debian.org>
+Maintainer: Debian QA Group <packages@qa.debian.org> 
 Section: utils
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -14,13 +14,16 @@
                libboost-program-options-dev,
                libboost-thread-dev,
                libcrypto++-dev (>= 5.6.4),
+               libgtest-dev,
+               libgmock-dev,
                libssl-dev,
                libfuse-dev,
                python3-all,
+               python3-versioneer,
 Rules-Requires-Root: no
 Standards-Version: 4.6.0.1
-Vcs-Browser: https://github.com/davesteele/cryfs
-Vcs-Git: https://github.com/davesteele/cryfs.git -b debian
+Vcs-Browser: https://salsa.debian.org/steele/cryfs
+Vcs-Git: https://salsa.debian.org/steele/cryfs.git -b debian
 Homepage: https://www.cryfs.org/
 
 Package: cryfs

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --builddirectory=build

override_dh_auto_configure:
	mkdir -p build
	dpkg-architecture
	if `dpkg-architecture -e armel` || `dpkg-architecture -e armhf` || `dpkg-architecture -e s390x`; then \
	    echo "Performing armel build"; \
	    dh_auto_configure -- -DDISABLE_ASM=ON -DDEPENDENCY_CONFIG=../cmake-utils/DependenciesFromLocalSystem.cmake -DBUILD_TESTING=ON -DCRYFS_UPDATE_CHECKS=OFF; \
	else \
	    dh_auto_configure -- -DDEPENDENCY_CONFIG=../cmake-utils/DependenciesFromLocalSystem.cmake -DBUILD_TESTING=ON -DCRYFS_UPDATE_CHECKS=OFF; \
	fi

override_dh_auto_test:
	./build/test/blobstore/blobstore-test 2>&1
	./build/test/blockstore/blockstore-test --gtest_filter='-CacheTest_RaceCondition.*' 2>&1
	# Config Compatibility tests fail on s390x, mipsel, and hppa archs
	./build/test/cryfs/cryfs-test --gtest_filter='-CryConfigCompatibilityTest.*' 2>&1
	./build/test/parallelaccessstore/parallelaccessstore-test 2>&1
	./build/test/gitversion/gitversion-test 2>&1
	# Test fails with pbuilder, and mipsel
	# ./build/test/cpp-utils/cpp-utils-test --gtest_filter='-HomedirTest.*' 2>&1
	# ./build/test/cryfs-cli/cryfs-cli-test
	# Test requires root (and fuse)
	# ./build/test/fspp/fspp-test

## cryfs 1.0.1

=== debian/changelog ===
cryfs (1.0.1-1) unstable; urgency=medium

  * New upstream version 1.0.1.
  * Adopt package (Closes: #1093400).
  * Added patch to support fuse3 (Closes: #1084454).
  * Added patch to fix boost 1.88 build failure (Closes: #1110579).
  * Updated system libcrypto++ patch.
  * Updated d/copyright with new files.
  * Updated d/watch file to watch for tags.
  * Updated d/gbp.conf file.

 -- Syed Shahrukh Hussain <syed.shahrukh@ossrevival.org>  Tue, 25 Nov 2025 12:56:11 +0500

=== debian/control ===
Source: cryfs
Maintainer: Syed Shahrukh Hussain <syed.shahrukh@ossrevival.org>
Section: utils
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               pkgconf,
               librange-v3-dev,
               libspdlog-dev,
               libcurl4-openssl-dev,
               libboost-filesystem1.88-dev,
               libboost-system1.88-dev,
               libboost-chrono1.88-dev,
               libboost-program-options1.88-dev,
               libboost-process1.88-dev,
               libboost-thread1.88-dev,
               libcrypto++-dev (>= 5.6.4),
               libssl-dev,
               libfuse3-dev,
               python3-all,
               python3-versioneer,
               libgtest-dev,
               libgmock-dev,
Rules-Requires-Root: no
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/syed/cryfs
Vcs-Git: https://salsa.debian.org/syed/cryfs.git -b debian/latest
Homepage: https://www.cryfs.org/

Package: cryfs
Architecture: linux-any
Depends: fuse3,
         ${misc:Depends},
         ${shlibs:Depends}
Description: encrypt your files and store them in the cloud
 CryFS encrypts your files, so you can safely store them anywhere. It works
 well together with cloud services like Dropbox, iCloud, OneDrive and others.

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 4 file
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%cryfs-$1.tar.gz%" \
    https://github.com/cryfs/cryfs/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## cryfs 1.0.3

=== debian/changelog ===
cryfs (1.0.3-1) unstable; urgency=medium

  * New upstream version 1.0.3.
  * Update debian copyright in d/copyright.
  * Update patches for new release.
  * Bump Standards-Version to 4.7.3.

 -- Syed Shahrukh Hussain <syed.shahrukh@ossrevival.org>  Tue, 10 Feb 2026 20:00:11 +0500

=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
                libgtest-dev,
                libgmock-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/syed/cryfs
 Vcs-Git: https://salsa.debian.org/syed/cryfs.git -b debian/latest
 Homepage: https://www.cryfs.org/
